<template>
  <div class="container">
    <h2>New RelMonsterSkill</h2>
    <b-form-input
      v-model="monster_id"
      required
      placeholder="monster id"
      type="number">
    </b-form-input>
    <small>In case you don't know the monster id, visit <nuxt-link to="/admin/monsters">monsters</nuxt-link></small>
    <b-form-input
      v-model="skill_id"
      required
      placeholder="skill id"
      type="number">
    </b-form-input>
    <small>In case you don't know the skill id, visit <nuxt-link to="/admin/skills">skills</nuxt-link></small>
    <div class="buttons">
      <b-button-group>
        <b-button 
          variant="success"
          @click="submit"
          :disabled="!valid">Submit</b-button>
        <b-button 
          variant="danger"
          @click="cancel">Cancel</b-button>
      </b-button-group>
    </div>
    <div>
      <b-alert
        :show="error != ''"
        variant="danger">
        {{ error }}
      </b-alert>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      skill_id: '',
      monster_id: '',
      error: ''
    };
  },
  computed: {
    valid() {
      return this.monster_id * this.skill_id > 0;
    }
  },
  methods: {
    submit() {
      let data = {
        rel_monster_skill: {
          skill_id: this.skill_id,
          monster_id: this.monster_id,
        }
      },
      ins = this;

      this.error = '';

      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/rel_monster_skills',
        data: data
      })
        .then(res => {
          ins.$router.go();
        })
        .catch(err => {
          ins.error = 'Ocorreu um erro... :(';
        })
    },
    cancel() {
      this.error = '';
      this.skill_id = '';
      this.monster_id = '';
    }
  }
}
</script>

<style>
.container {
  max-width: 35vw;
  border: 0.2rem solid lightgray;
  border-radius: 10px;
  padding: 1rem;
}

.buttons {
  display: flex;
  justify-content: center;
}
</style>
